module PWM(sov_out,clk,toggle_flag,Rst_n);
			  
	input clk;
	input Rst_n;
	input [17:0]toggle_flag;       //tf
	output sov_out;


	reg [17:0]cnt;           //max is 24_0000(D) -> 3 A980(H)
	reg [17:0]tf_middle_num; //中间变量
	reg [17:0]pwn_toggle_flag;

	//counter
	always@(posedge clk or negedge Rst_n) begin
		if (!Rst_n)
			cnt <= 18'b0;
		else if (cnt == 23_9999)
			cnt <= 18'b0;
		else
			cnt <= cnt + 18'b1;
	end

	//limit the pwn_toggle_flga
	always@(posedge clk or negedge Rst_n) begin
		if (!Rst_n)
			tf_middle_num <= 0;
		else if (tf_middle_num > 29000)
			tf_middle_num <= 29000;
		else if (tf_middle_num < 6000)
			tf_middle_num <= 6000;
		else
			tf_middle_num <= toggle_flag;
	end

	//set the pwn_toggle_flga
	always@(posedge clk or negedge Rst_n) begin
		if (!Rst_n)
			pwn_toggle_flag <= 0;
		else
			pwn_toggle_flag <= tf_middle_num;
	end

	assign sov_out =(cnt<=pwn_toggle_flag)?1'b1:1'b0; //compare and output

endmodule 