module command_analysis(clk,Rst_n,command,angle_L1,angle_L2,angle_L3,angle_L4,angle_L5,angle_L6,angle_L7,angle_L8,angle_L9,angle_R1,angle_R2,angle_R3,angle_R4,angle_R5,angle_R6,angle_R7,angle_R8,angle_R9);

	input clk;              //12M
	input Rst_n;      
	input [7:0]command;     //command
	
   //target angle for each servo	
	output reg		[7:0]	angle_L1;
	output reg		[7:0]	angle_L2;
	output reg		[7:0]	angle_L3;
	output reg		[7:0]	angle_L4;
	output reg		[7:0]	angle_L5;
	output reg		[7:0]	angle_L6;
	output reg		[7:0]	angle_L7;
	output reg		[7:0]	angle_L8;
	output reg		[7:0]	angle_L9;
	output reg		[7:0]	angle_R1;
	output reg		[7:0]	angle_R2;
	output reg		[7:0]	angle_R3;
	output reg		[7:0]	angle_R4;
	output reg		[7:0]	angle_R5;
	output reg		[7:0]	angle_R6;
	output reg		[7:0]	angle_R7;
	output reg		[7:0]	angle_R8;
	output reg		[7:0]	angle_R9;

	reg		[7:0]	action_state;
	
	reg		[30:0]	cnt_mf			=	30'd0;
	reg		[30:0]	cnt_mb			=	30'd0;
	reg		[30:0]	cnt_tl			=	30'd0;
	reg		[30:0]	cnt_tr			=	30'd0;

	parameter	MOVE_FOWARD		= 8'b00000001; //1
	parameter	MOVE_BACK		= 8'b00000010; //2
	parameter	TURN_LEFT		= 8'b00000011; //3
	parameter	TURN_RIGHT		= 8'b00000100; //4
	parameter	STOP			   = 8'b00000000;	//0  stop the same as servo init
	parameter   TEST           = 8'b00000101; //5  test the servo

	
	always@(posedge clk or negedge Rst_n)begin
		if (!Rst_n)
			action_state <= 0;
		else begin
			case (command)
				MOVE_FOWARD:  action_state <= MOVE_FOWARD;
				MOVE_BACK:	  action_state <= MOVE_BACK;
				TURN_LEFT:	  action_state <= TURN_LEFT;
				TURN_RIGHT:   action_state <= TURN_RIGHT;
				STOP:         action_state <= STOP;
				TEST:         action_state <= TEST;
			endcase	
		end		
	end

	always@(posedge clk or negedge Rst_n)begin
		if (!Rst_n)begin
			angle_L1 	<= 8'd90;
			angle_L2 	<= 8'd90;
			angle_L3 	<= 8'd90;
			angle_L4 	<= 8'd90;
			angle_L5 	<= 8'd90;
			angle_L6 	<= 8'd90;
			angle_L7 	<= 8'd90;
			angle_L8 	<= 8'd90;
			angle_L9 	<= 8'd90;
			angle_R1 	<= 8'd90;
			angle_R2 	<= 8'd90;
			angle_R3 	<= 8'd90;
			angle_R4 	<= 8'd90;
			angle_R5 	<= 8'd90;
			angle_R6 	<= 8'd90;
			angle_R7 	<= 8'd90;
			angle_R8 	<= 8'd90;
			angle_R9 	<= 8'd90;
		end	
		else begin
			case (action_state)
				TURN_LEFT: begin
					if (!Rst_n)begin
						angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;
						angle_L4 <= 8'd90;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;
						angle_L7 <= 8'd90;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
						angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
						angle_R4 <= 8'd90;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
						angle_R7 <= 8'd90;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90;
						cnt_mf   <= 30'd0; 						
					end
					else if(cnt_mf == 30'd14000000)
						cnt_mf   <= 30'd0;
					else begin
						cnt_mf <= cnt_mf + 1'b1;
						case(cnt_mf)
							30'd0: //组1向前方向抬腿 组2拉回
								begin 
									angle_L1 <= 8'd135;	angle_L2 <= 8'd135; angle_L3 <= 8'd90;	
									angle_L4 <= 8'd70;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;	
									angle_L7 <= 8'd115;	angle_L8 <= 8'd135;	angle_L9 <= 8'd90;	//90-135	——>	70-115
									angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd75;	angle_R5 <= 8'd45;	angle_R6 <= 8'd90;	//45-90		——>	75-110
									angle_R7 <= 8'd110;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90;
								end
											
							30'd350_0000://组1落腿 
								begin 
									angle_L1 <= 8'd135;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;	
									angle_L4 <= 8'd70;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;
									angle_L7 <= 8'd115;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd75;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
									angle_R7 <= 8'd110;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90;
								end
												
							30'd700_0000://组1拉回  组2抬腿向前
								begin 
									angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;	
									angle_L4 <= 8'd115;	angle_L5 <= 8'd135;	angle_L6 <= 8'd90;		//90-135——>	70-115
									angle_L7 <= 8'd70;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd45;	angle_R2 <= 8'd45;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd110;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;		
									angle_R7 <= 8'd75;	angle_R8 <= 8'd45;	angle_R9 <= 8'd90;		//45-90	——>	75-110
								end	

							30'd1050_0000:  //组2落腿 
								begin 
									angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;	
									angle_L4 <= 8'd115;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;
									angle_L7 <= 8'd70;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd45;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd110;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
									angle_R7 <= 8'd75;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90;
								end
							default:
								begin
									angle_L1 <= angle_L1;	angle_L4 <= angle_L4;	angle_L7 <= angle_L7;
									angle_L2 <= angle_L2;	angle_L5 <= angle_L5;   angle_L8 <= angle_L8;
									angle_L3 <= angle_L3;	angle_L6 <= angle_L6;   angle_L9 <= angle_L9;
									angle_R1 <= angle_R1;	angle_R4 <= angle_R4;	angle_R7 <= angle_R7;
									angle_R2 <= angle_R2;   angle_R5 <= angle_R5;   angle_R8 <= angle_R8;
									angle_R3 <= angle_R3;   angle_R6 <= angle_R6;   angle_R9 <= angle_R9;
								end
						endcase						
					end
				end
				
				TURN_RIGHT:begin
					if (!Rst_n)begin
						angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;
						angle_L4 <= 8'd90;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;
						angle_L7 <= 8'd90;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
						angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
						angle_R4 <= 8'd90;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
						angle_R7 <= 8'd90;	angle_R8 <= 8'd90;	angle_R9 <= 8'd95;
						cnt_mb   <= 30'd0; 						
					end
					else if(cnt_mb == 30'd14000000)
						cnt_mb   <= 30'd0;
					else begin
						cnt_mb <= cnt_mb + 1'b1;
						case(cnt_mb)
							30'd0: 
								begin
									angle_L1 <= 8'd75;	angle_L2 <= 8'd125; angle_L3 <= 8'd90;	
									angle_L4 <= 8'd115;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;	
									angle_L7 <= 8'd75;	angle_L8 <= 8'd135;	angle_L9 <= 8'd90;	
									angle_R1 <= 8'd75;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd110;	angle_R5 <= 8'd45;	angle_R6 <= 8'd90;	
									angle_R7 <= 8'd70;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90;
								end
											
							30'd350_0000:
								begin 
									angle_L1 <= 8'd75;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;	
									angle_L4 <= 8'd115;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;
									angle_L7 <= 8'd75;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd75;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd110;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
									angle_R7 <= 8'd70;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90;
								end
												
							30'd7000000:
								begin 
									angle_L1 <= 8'd110;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;	
									angle_L4 <= 8'd70;	angle_L5 <= 8'd135;	angle_L6 <= 8'd90;		
									angle_L7 <= 8'd110;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd110;	angle_R2 <= 8'd45;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd75;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
									angle_R7 <= 8'd115;	angle_R8 <= 8'd45;	angle_R9 <= 8'd90;
								end	

							30'd10500000:  //组2落腿 
								begin 
									angle_L1 <= 8'd110;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;	
									angle_L4 <= 8'd70;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;
									angle_L7 <= 8'd110;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd110;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd75;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
									angle_R7 <= 8'd115;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90;
								end
							default:
								begin
									angle_L1 <= angle_L1;	angle_L4 <= angle_L4;	angle_L7 <= angle_L7;
									angle_L2 <= angle_L2;	angle_L5 <= angle_L5;   angle_L8 <= angle_L8;
									angle_L3 <= angle_L3;	angle_L6 <= angle_L6;   angle_L9 <= angle_L9;
									angle_R1 <= angle_R1;	angle_R4 <= angle_R4;	angle_R7 <= angle_R7;
									angle_R2 <= angle_R2;   angle_R5 <= angle_R5;   angle_R8 <= angle_R8;
									angle_R3 <= angle_R3;   angle_R6 <= angle_R6;   angle_R9 <= angle_R9;
								end
						endcase						
					end
				end
				MOVE_FOWARD:begin
					if(!Rst_n) begin 	
						angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;
						angle_L4 <= 8'd90;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;
						angle_L7 <= 8'd90;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
						angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
						angle_R4 <= 8'd90;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
						angle_R7 <= 8'd90;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100; 
						cnt_tl <= 24'd0;	end	
					else if(cnt_tl == 30'd14000000)
						cnt_tl <= 30'd0;
					else begin 
						cnt_tl <= cnt_tl + 1'b1;
						case(cnt_tr) 
							30'd0: 
								begin
									angle_L1 <= 8'd70;	angle_L2 <= 8'd135;  angle_L3 <= 8'd100;	
									angle_L4 <= 8'd110;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;	
									angle_L7 <= 8'd65;	angle_L8 <= 8'd135;	angle_L9 <= 8'd90;	
									angle_R1 <= 8'd110;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd75;	angle_R5 <= 8'd45;	angle_R6 <= 8'd95;	
									angle_R7 <= 8'd110;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100;
								end
											
							30'd350_0000:
								begin 
									angle_L1 <= 8'd70;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;	
									angle_L4 <= 8'd110;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;
									angle_L7 <= 8'd65;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd110;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd75;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
									angle_R7 <= 8'd110;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100;
								end
												
							30'd7000000:
								begin 
									angle_L1 <= 8'd120;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;	
									angle_L4 <= 8'd75;	angle_L5 <= 8'd135;	angle_L6 <= 8'd100;
									angle_L7 <= 8'd115;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd75;	angle_R2 <= 8'd45;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd110;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
									angle_R7 <= 8'd75;	angle_R8 <= 8'd45;	angle_R9 <= 8'd100;
								end

							30'd10500000:  
								begin 
									angle_L1 <= 8'd120;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;	
									angle_L4 <= 8'd75;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;
									angle_L7 <= 8'd115;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd75;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd110;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
									angle_R7 <= 8'd75;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100;
								end
										
							default:
								begin
									angle_L1 <= angle_L1;	angle_L4 <= angle_L4;	angle_L7 <= angle_L7;
									angle_L2 <= angle_L2;	angle_L5 <= angle_L5;   angle_L8 <= angle_L8;
									angle_L3 <= angle_L3;	angle_L6 <= angle_L6;   angle_L9 <= angle_L9;
									angle_R1 <= angle_R1;	angle_R4 <= angle_R4;	angle_R7 <= angle_R7;
									angle_R2 <= angle_R2;   angle_R5 <= angle_R5;   angle_R8 <= angle_R8;
									angle_R3 <= angle_R3;   angle_R6 <= angle_R6;   angle_R9 <= angle_R9;
								end
						endcase						
					end
				end
				MOVE_BACK:begin
					if(!Rst_n) begin 	
						angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;
						angle_L4 <= 8'd90;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;
						angle_L7 <= 8'd90;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
						angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
						angle_R4 <= 8'd90;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
						angle_R7 <= 8'd90;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100; 
						cnt_tl <= 24'd0;
					end
					else if(cnt_tr == 25'd14000000)
						cnt_tr <= 24'd0;
					else begin 
						cnt_tr <= cnt_tr + 1'b1;
						case(cnt_tr) 
							30'd0: 
								begin
									angle_L1 <= 8'd75;	angle_L2 <= 8'd135;  angle_L3 <= 8'd100;	
									angle_L4 <= 8'd110;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;	
									angle_L7 <= 8'd75;	angle_L8 <= 8'd135;	angle_L9 <= 8'd90;	
									angle_R1 <= 8'd110;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd75;	angle_R5 <= 8'd45;	angle_R6 <= 8'd95;	
									angle_R7 <= 8'd110;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100;
								end
											
							30'd350_0000:
								begin 
									angle_L1 <= 8'd75;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;	
									angle_L4 <= 8'd110;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;
									angle_L7 <= 8'd75;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd110;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd75;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
									angle_R7 <= 8'd110;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100;
								end
												
							30'd7000000:
								begin 
									angle_L1 <= 8'd110;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;	
									angle_L4 <= 8'd75;	angle_L5 <= 8'd135;	angle_L6 <= 8'd100;
									angle_L7 <= 8'd110;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd75;	angle_R2 <= 8'd45;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd110;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
									angle_R7 <= 8'd75;	angle_R8 <= 8'd45;	angle_R9 <= 8'd100;
								end

							30'd10500000:  
								begin 
									angle_L1 <= 8'd120;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;	
									angle_L4 <= 8'd75;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;
									angle_L7 <= 8'd115;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
									angle_R1 <= 8'd75;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
									angle_R4 <= 8'd110;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
									angle_R7 <= 8'd75;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100;
								end
										
							default:
								begin
									angle_L1 <= angle_L1;	angle_L4 <= angle_L4;	angle_L7 <= angle_L7;
									angle_L2 <= angle_L2;	angle_L5 <= angle_L5;   angle_L8 <= angle_L8;
									angle_L3 <= angle_L3;	angle_L6 <= angle_L6;   angle_L9 <= angle_L9;
									angle_R1 <= angle_R1;	angle_R4 <= angle_R4;	angle_R7 <= angle_R7;
									angle_R2 <= angle_R2;   angle_R5 <= angle_R5;   angle_R8 <= angle_R8;
									angle_R3 <= angle_R3;   angle_R6 <= angle_R6;   angle_R9 <= angle_R9;
								end
						endcase						
					end
				end
				STOP:begin
					angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd100;
					angle_L4 <= 8'd90;	angle_L5 <= 8'd90;	angle_L6 <= 8'd100;
					angle_L7 <= 8'd90;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
					angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
					angle_R4 <= 8'd90;	angle_R5 <= 8'd90;	angle_R6 <= 8'd95;
					angle_R7 <= 8'd90;	angle_R8 <= 8'd90;	angle_R9 <= 8'd100; 
				end
				TEST:begin
					if (!Rst_n)begin
						angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;
						angle_L4 <= 8'd90;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;
						angle_L7 <= 8'd90;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
						angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
						angle_R4 <= 8'd90;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
						angle_R7 <= 8'd90;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90; 						
						cnt_tr   <= 24'd0;
					end
					else if(cnt_tr == 25'd2000000)begin
						angle_L1 <= angle_L1 + 1'b1; angle_R1 <= angle_L3 + 1'b1;
						angle_L2 <= angle_L2 + 1'b1; angle_R2 <= angle_L3 + 1'b1;
						angle_L3 <= angle_L3 + 1'b1; angle_R3 <= angle_L3 + 1'b1;
						angle_L4 <= angle_L3 + 1'b1; angle_R4 <= angle_L3 + 1'b1;
						angle_L5 <= angle_L3 + 1'b1; angle_R5 <= angle_L3 + 1'b1;
						angle_L6 <= angle_L3 + 1'b1; angle_R6 <= angle_L3 + 1'b1;
						angle_L7 <= angle_L3 + 1'b1; angle_R7 <= angle_L3 + 1'b1;
						angle_L8 <= angle_L3 + 1'b1; angle_R8 <= angle_L3 + 1'b1;
						angle_L9 <= angle_L3 + 1'b1; angle_R9 <= angle_L3 + 1'b1;
						cnt_tr   <= 0;
					end
					else if(angle_L1 > 135)begin
						angle_L1 <= 8'd90;	angle_L2 <= 8'd90; 	angle_L3 <= 8'd90;
						angle_L4 <= 8'd90;	angle_L5 <= 8'd90;	angle_L6 <= 8'd90;
						angle_L7 <= 8'd90;	angle_L8 <= 8'd90;	angle_L9 <= 8'd90;
						angle_R1 <= 8'd90;	angle_R2 <= 8'd90;	angle_R3 <= 8'd90;
						angle_R4 <= 8'd90;	angle_R5 <= 8'd90;	angle_R6 <= 8'd90;
						angle_R7 <= 8'd90;	angle_R8 <= 8'd90;	angle_R9 <= 8'd90;
					end
					else
						cnt_tr	<= cnt_tr + 1'b1;
				end
				
				default:
					begin
						angle_L1 <= angle_L1;	angle_L4 <= angle_L4;	angle_L7 <= angle_L7;
						angle_L2 <= angle_L2;	angle_L5 <= angle_L5;   angle_L8 <= angle_L8;
						angle_L3 <= angle_L3;	angle_L6 <= angle_L6;   angle_L9 <= angle_L9;
						angle_R1 <= angle_R1;	angle_R4 <= angle_R4;	angle_R7 <= angle_R7;
						angle_R2 <= angle_R2;   angle_R5 <= angle_R5;   angle_R8 <= angle_R8;
						angle_R3 <= angle_R3;   angle_R6 <= angle_R6;   angle_R9 <= angle_R9;
					end			
			endcase
		end
	end
endmodule 