module top(clk,Rst_n,Rs232_Rx,outr1,outr2,outr3,outr4,outr5,outr6,outr7,outr8,outr9,outl1,outl2,outl3,outl4,outl5,outl6,outl7,outl8,outl9);

	input clk;
	input Rst_n;
	input Rs232_Rx;
	
	output outr1;
	output outr2;
	output outr3;
	output outr4;
	output outr5;
	output outr6;
	output outr7;
	output outr8;
	output outr9;
	output outl1;
	output outl2;
	output outl3;
	output outl4;
	output outl5;
	output outl6;
	output outl7;
	output outl8;
	output outl9;
	
	wire [7:0]command;
	wire [7:0]angle_R1;
	wire [7:0]angle_R2;
	wire [7:0]angle_R3;
	wire [7:0]angle_R4;
	wire [7:0]angle_R5;
	wire [7:0]angle_R6;
	wire [7:0]angle_R7;
	wire [7:0]angle_R8;
	wire [7:0]angle_R9;
	wire [7:0]angle_L1;
	wire [7:0]angle_L2;
	wire [7:0]angle_L3;
	wire [7:0]angle_L4;
	wire [7:0]angle_L5;
	wire [7:0]angle_L6;
	wire [7:0]angle_L7;
	wire [7:0]angle_L8;
	wire [7:0]angle_L9;

	reg [7:0]data_rx_r;
	wire [7:0]data_rx;
	wire Rx_Done;
	
	uart_byte_rx uart_byte_rx(
		.Clk(clk),
		.Rst_n(Rst_n),
		.baud_set(3'd0),
		.Rs232_Rx(Rs232_Rx),
		.data_byte(data_rx),
		.Rx_Done(Rx_Done)
	);
	
	always@(posedge clk or negedge Rst_n)
	if(!Rst_n)
		data_rx_r <= 8'd0;
	else if(Rx_Done)
		data_rx_r <= data_rx;
	else
		data_rx_r <= data_rx_r;
		
	assign command = data_rx_r;
	
	command_analysis  commands(.clk(clk),
										.Rst_n(Rst_n),
										.command(command),
										.angle_L1(angle_L1),
										.angle_L2(angle_L2),
										.angle_L3(angle_L3),
										.angle_L4(angle_L4),
										.angle_L5(angle_L5),
										.angle_L6(angle_L6),
										.angle_L7(angle_L7),
										.angle_L8(angle_L8),
										.angle_L9(angle_L9),
										.angle_R1(angle_R1),
										.angle_R2(angle_R2),
										.angle_R3(angle_R3),
										.angle_R4(angle_R4),
										.angle_R5(angle_R5),
										.angle_R6(angle_R6),
										.angle_R7(angle_R7),
										.angle_R8(angle_R8),
										.angle_R9(angle_R9)
										);
	wire [17:0]tfr1;
	wire [17:0]tfr2;
	wire [17:0]tfr3;
	wire [17:0]tfr4;
	wire [17:0]tfr5;
	wire [17:0]tfr6;
	wire [17:0]tfr7;
	wire [17:0]tfr8;
	wire [17:0]tfr9;
	wire [17:0]tfl1;
	wire [17:0]tfl2;
	wire [17:0]tfl3;
	wire [17:0]tfl4;
	wire [17:0]tfl5;
	wire [17:0]tfl6;
	wire [17:0]tfl7;
	wire [17:0]tfl8;
	wire [17:0]tfl9;
	
	angle_to_tf angtfr1(.clk(clk),.Rst_n(Rst_n),.angle(angle_R1),.toggle_flag(tfr1));
	angle_to_tf angtfr2(.clk(clk),.Rst_n(Rst_n),.angle(angle_R2),.toggle_flag(tfr2));
	angle_to_tf angtfr3(.clk(clk),.Rst_n(Rst_n),.angle(angle_R3),.toggle_flag(tfr3));
	angle_to_tf angtfr4(.clk(clk),.Rst_n(Rst_n),.angle(angle_R4),.toggle_flag(tfr4));
	angle_to_tf angtfr5(.clk(clk),.Rst_n(Rst_n),.angle(angle_R5),.toggle_flag(tfr5));
	angle_to_tf angtfr6(.clk(clk),.Rst_n(Rst_n),.angle(angle_R6),.toggle_flag(tfr6));
	angle_to_tf angtfr7(.clk(clk),.Rst_n(Rst_n),.angle(angle_R7),.toggle_flag(tfr7));
	angle_to_tf angtfr8(.clk(clk),.Rst_n(Rst_n),.angle(angle_R8),.toggle_flag(tfr8));
	angle_to_tf angtfr9(.clk(clk),.Rst_n(Rst_n),.angle(angle_R9),.toggle_flag(tfr9));
	angle_to_tf angtfl1(.clk(clk),.Rst_n(Rst_n),.angle(angle_L1),.toggle_flag(tfl1));
	angle_to_tf angtfl2(.clk(clk),.Rst_n(Rst_n),.angle(angle_L2),.toggle_flag(tfl2));
	angle_to_tf angtfl3(.clk(clk),.Rst_n(Rst_n),.angle(angle_L3),.toggle_flag(tfl3));
	angle_to_tf angtfl4(.clk(clk),.Rst_n(Rst_n),.angle(angle_L4),.toggle_flag(tfl4));
	angle_to_tf angtfl5(.clk(clk),.Rst_n(Rst_n),.angle(angle_L5),.toggle_flag(tfl5));
	angle_to_tf angtfl6(.clk(clk),.Rst_n(Rst_n),.angle(angle_L6),.toggle_flag(tfl6));
	angle_to_tf angtfl7(.clk(clk),.Rst_n(Rst_n),.angle(angle_L7),.toggle_flag(tfl7));
	angle_to_tf angtfl8(.clk(clk),.Rst_n(Rst_n),.angle(angle_L8),.toggle_flag(tfl8));
	angle_to_tf angtfl9(.clk(clk),.Rst_n(Rst_n),.angle(angle_L9),.toggle_flag(tfl9));
	
	wire sov_outr1;
	wire sov_outr2;
	wire sov_outr3;
	wire sov_outr4;
	wire sov_outr5;
	wire sov_outr6;
	wire sov_outr7;
	wire sov_outr8;
	wire sov_outr9;
	wire sov_outl1;
	wire sov_outl2;
	wire sov_outl3;
	wire sov_outl4;
	wire sov_outl5;
	wire sov_outl6;
	wire sov_outl7;
	wire sov_outl8;
	wire sov_outl9;
	
	PWM pwmr1(.sov_out(sov_outr1),.clk(clk),.toggle_flag(tfr1),.Rst_n(Rst_n));
	PWM pwmr2(.sov_out(sov_outr2),.clk(clk),.toggle_flag(tfr2),.Rst_n(Rst_n));
	PWM pwmr3(.sov_out(sov_outr3),.clk(clk),.toggle_flag(tfr3),.Rst_n(Rst_n));
	PWM pwmr4(.sov_out(sov_outr4),.clk(clk),.toggle_flag(tfr4),.Rst_n(Rst_n));
	PWM pwmr5(.sov_out(sov_outr5),.clk(clk),.toggle_flag(tfr5),.Rst_n(Rst_n));
	PWM pwmr6(.sov_out(sov_outr6),.clk(clk),.toggle_flag(tfr6),.Rst_n(Rst_n));
	PWM pwmr7(.sov_out(sov_outr7),.clk(clk),.toggle_flag(tfr7),.Rst_n(Rst_n));
	PWM pwmr8(.sov_out(sov_outr8),.clk(clk),.toggle_flag(tfr8),.Rst_n(Rst_n));
	PWM pwmr9(.sov_out(sov_outr9),.clk(clk),.toggle_flag(tfr9),.Rst_n(Rst_n));
	PWM pwml1(.sov_out(sov_outl1),.clk(clk),.toggle_flag(tfl1),.Rst_n(Rst_n));
	PWM pwml2(.sov_out(sov_outl2),.clk(clk),.toggle_flag(tfl2),.Rst_n(Rst_n));
	PWM pwml3(.sov_out(sov_outl3),.clk(clk),.toggle_flag(tfl3),.Rst_n(Rst_n));
	PWM pwml4(.sov_out(sov_outl4),.clk(clk),.toggle_flag(tfl4),.Rst_n(Rst_n));
	PWM pwml5(.sov_out(sov_outl5),.clk(clk),.toggle_flag(tfl5),.Rst_n(Rst_n));
	PWM pwml6(.sov_out(sov_outl6),.clk(clk),.toggle_flag(tfl6),.Rst_n(Rst_n));
	PWM pwml7(.sov_out(sov_outl7),.clk(clk),.toggle_flag(tfl7),.Rst_n(Rst_n));
	PWM pwml8(.sov_out(sov_outl8),.clk(clk),.toggle_flag(tfl8),.Rst_n(Rst_n));
	PWM pwml9(.sov_out(sov_outl9),.clk(clk),.toggle_flag(tfl9),.Rst_n(Rst_n));
	
	assign outr1 = sov_outr1;
	assign outr2 = sov_outr2;
	assign outr3 = sov_outr3;
	assign outr4 = sov_outr4;
	assign outr5 = sov_outr5;
	assign outr6 = sov_outr6;
	assign outr7 = sov_outr7;
	assign outr8 = sov_outr8;
	assign outr9 = sov_outr9;
	assign outl1 = sov_outl1;
	assign outl2 = sov_outl2;
	assign outl3 = sov_outl3;
	assign outl4 = sov_outl4;
	assign outl5 = sov_outl5;
	assign outl6 = sov_outl6;
	assign outl7 = sov_outl7;
	assign outl8 = sov_outl8;
	assign outl9 = sov_outl9;
	
endmodule 